#ifndef NET_PCAP_H
#define NET_PCAP_H

#include <QNetworkInterface>
#include "QString"

#if (defined(Q_WS_WIN))
#include "pcap.h"
#else
#include <pcap.h>
#endif

#define ETHERTYPE_INTELLON	0x887b

#define CAPABILITIES_TX 1
#define CAPABILITIES_RX 0
extern unsigned char capabilities_flag;

extern unsigned int buflen;

extern unsigned short ex_word(const unsigned char *ptr);
extern uint32_t  ex_long(const unsigned char *ptr);
extern char *format_mac_addr(const unsigned char *addr, char *macbuf);

extern int plcnet_select_if(const QNetworkInterface interf);
extern int plcnet_send_req(const void *buf, size_t len, const QString to_mac);
extern int plcnet_register_callback(pcap_handler callback, u_char *args);
extern int plcnet_deinit();

extern int plc_set_network_key(const QString& mac, const QString& key);
extern int plc_broadcast_key();
extern int plc_send_mm();
extern int plc_req_version(const QString& mac);
extern int plc_get_channel_capacities();

void plc_net_callback(u_char *args, const struct pcap_pkthdr *header, const u_char *packet);

#if 0
extern int plc_req_param_stat();
extern int plc_broadcast_key();
extern int plc_req_intellon_specific();
extern int plc_deinit();
extern int plc_get_device_version(const QString& mac);
extern int plc_read_display_response();
extern int plc_req_perf_stat();
extern int plc_req_channel_estimation();
#endif

#endif
